// #autoload
// #name = PlayerAnnounce
// #version = 0.5
// #date = February 13, 2003
// #author = ilys
// #warrior = ilys
// #description = Tells you when someone has join or left the server and when someone has join yours or the enemies team.
// #status = beta
// #category = ilys' Scripts
// #credits = X2 for the idea. Pretend for the reason.
// #config = PlayerAnnounceGUI
// #include = support/callback.cs
// #include = support/player_support.cs

$PA::Sounds = 1;
$PA::Time = 5000;
$PA::Trans = 1;
$PA::YouJoinTeam = 1;
$PA::YouJoinObs = 1;
$PA::TheyJoinTeam = 1;
$PA::TheyJoinObs = 1;
$PA::TheyJoinYourTeam = 1;
$PA::TheyJoinEnemyTeam = 1;
$PA::TheyJoinServer = 1;
$PA::TheyLeaveServer = 1;
$PA::ObsLeaveServer = 1;
$PA::TeamMateLeaveServer = 1;
$PA::EnemyLeaveServer = 1;
$PA::PlayerJoinId = 5;
$PA::ObsDropId = 2;
$PA::TeamDropId = 1;
$PA::EnemyDropId = 0;
$PA::PlayerDropId = 6;
$PA::SelfJoinTeamId = 3;
$PA::SelfJoinObsId = 3;
$PA::PlayerJoinObsId = 2;
$PA::PlayerJoinSelfTeamId = 1;
$PA::PlayerJoinEnemyTeamId = 0;
$PA::PlayerJoinTeamId = 4;

if(!isFile("prefs/PlayerAnnouncePrefs.cs"))
	export("$PA::*", "prefs/PlayerAnnouncePrefs.cs", false);

exec("prefs/PlayerAnnouncePrefs.cs");

package PlayerAnnounce
{
	function PlayGui::onWake(%this)
	{
		callback.add(CallbackMsgClientJoin, "handlePAJoin");
		callback.add(CallbackMsgClientJoinTeam, "handlePAJoinTeam");
		callback.add(CallbackMsgClientDrop, "handlePADrop");

		parent::onWake(%this);

		if(!isObject(PlayGui)) return;
		
		if(isObject(PlayerAnnounceHUD)) return;

		new GuiControlProfile ("PARed")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "255 0 0";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		new GuiControlProfile ("PAGreen")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "23 236 67";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		new GuiControlProfile ("PABlue")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "67 67 255";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		new GuiControlProfile ("PAYellow")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "255 205 0";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		new GuiControlProfile ("PAOrange")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "255 150 0";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		new GuiControlProfile ("PAWhite")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "169 215 250";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		new GuiControlProfile ("PABlack")
		{
			fontType = "Supertouch";
			fontSize = 14;
			fontColor = "0 0 0";
			autoSizeWidth = false;
			autoSizeHeight = true;
			justify = "center";
		};

		%posX = getWord(outerChatHud.position, 0);
		%extentX = getWord(outerChatHud.extent, 0);
		%posY = getWord(outerChatHud.extent, 1);

		new ShellFieldCtrl(PlayerAnnounceHUD)
		{
			horizSizing = "right";
			vertSizing = "bottom";
			position = %posX @ " " @ (%posY + 10);
			extent = (%posX+%extentX-9) @ " " @ 18;
			minExtent = "8 8";
			visible = "0";

			new GuiTextCtrl(PlayerAnnounceText)
			{
				profile = "PAwhite";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "7 0";
				extent = (%posX+%extentX) @ " " @ 18;
				visible = "1";
			};
		};
		PlayerAnnounceHUD.profile = $PA::Trans ? "GuiConsoleProfile" : "GuiChatBackProfile";
		playGui.add(PlayerAnnounceHUD);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(PlayerAnnounceHUD,"PlayerAnnounceHUD");
	}
};
activatePackage(PlayerAnnounce);

function handlePAJoin(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
{
	commandToServer('getScores');
	%joinname = detag(%clientName);
	if(PlayGUI.isAwake())
	{
		if($PA::TheyJoinServer)
		{
			setPAProfile($PA::PlayerJoinId);
			%msg = %joinname @ " Joined The Game";
			DisplayMsg(%msg);
		}
	}
}

function handlePADrop(%msgType, %msgString, %clientName, %clientId)
{
	commandToServer('getScores');
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%joinname = detag(%clientName);
	%jointeam = PlayerList.getTeamByName(%joinname);
	if(PlayGUI.isAwake())
	{
		if(%jointeam == 0 && %myteam != 0 && $PA::ObsLeaveServer)
		{
			setPAProfile($PA::ObsDropId);
			%msg = "Observer, "@ %joinname @ " Left The Game";
			DisplayMsg(%msg);
		}
		else if(%jointeam == %myteam && %myteam != 0 && $PA::TeamMateLeaveServer)
		{
			setPAProfile($PA::TeamDropId);
			%msg = "Teammate, " @ %joinname @ " Left The Game";
			DisplayMsg(%msg);
		}
		else if(%jointeam != %myteam && %myteam != 0 && $PA::EnemyLeaveServer)
		{
			setPAProfile($PA::EnemyDropId);
			%msg = "Enemy, " @ %joinname @ " Left The Game";
			DisplayMsg(%msg);
		}
		else if($PA::TheyLeaveServer)
		{
			setPAProfile($PA::PlayerDropId);
			%msg = %joinname @ " Left The Game";
			DisplayMsg(%msg);
		}
	}
}

function handlePAJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
	commandToServer('getScores');
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%joinname = detag(%clientName);
	%jointeam = detag(%teamId);
	%jointeamname = detag(%teamName);
	if(PlayGUI.isAwake())
	{
		if(%joinname $= %myname)
		{
			if(%jointeam != 0 && $PA::YouJoinTeam)
			{
				setPAProfile($PA::SelfJoinTeamId);
				%msg = "You Joined " @ %jointeamname;
				DisplayMsg(%msg);
			}
			else if(%jointeam == 0 && $PA::YouJoinObs)
			{
				setPAProfile($PA::SelfJoinObsId);
				%msg = "You Joined The Observers";
				DisplayMsg(%msg);
			}
		}
		else
		{
			if (%jointeam == 0 && $PA::TheyJoinObs)
			{
				setPAProfile($PA::PlayerJoinObsId);
				%msg = %joinname @ " Joined The Observers";
				DisplayMsg(%msg);
			}
			if(%jointeam == %myteam && %myteam != 0 && $PA::TheyJoinYourTeam)
			{
				setPAProfile($PA::PlayerJoinSelfTeamId);
				%msg = %joinname @ " Joined Your Team";
				DisplayMsg(%msg);
			}
			if(%jointeam != %myteam && %jointeam != 0 && %myteam != 0 && $PA::TheyJoinEnemyTeam)
			{
				setPAProfile($PA::PlayerJoinEnemyTeamId);
				%msg = %joinname @ " Joined The Enemy Team";
				DisplayMsg(%msg);
			}
			if(%jointeam != %myteam && %myteam == 0 && $PA::TheyJoinTeam)
			{
				setPAProfile($PA::PlayerJoinTeamId);
				%msg = %joinname @ " Joined " @ %jointeamname;
				DisplayMsg(%msg);
			}
		}
	}
}

function setPAProfile(%Id)
{
	error(%Id);
	if(%Id == 0)
		PlayerAnnounceText.setProfile(PARed);
	else if(%Id == 1)
		PlayerAnnounceText.setProfile(PAGreen);
	else if(%Id == 2)
		PlayerAnnounceText.setProfile(PABlue);
	else if(%Id == 3)
		PlayerAnnounceText.setProfile(PAYellow);
	else if(%Id == 4)
		PlayerAnnounceText.setProfile(PAOrange);
	else if(%Id == 5)
		PlayerAnnounceText.setProfile(PAWhite);
	else if(%Id == 6)
		PlayerAnnounceText.setProfile(PABlack);
}
function DisplayMsg(%msg)
{
	if($PA::Sounds)
		alxPlay(alxCreateSource(AudioChat, "fx/misc/warning_beep.wav"));

	if(isEventPending($PASched))
	{
		ClearDisplayMsg();
		cancel($PASched);
	}
	PlayerAnnounceText.setValue(%msg);
	PlayerAnnounceHUD.setVisible(true);
	$PASched = schedule($PA::Time, 0, ClearDisplayMsg);
}

function ClearDisplayMsg()
{
	PlayerAnnounceText.setValue(" ");
	PlayerAnnounceHUD.setVisible(false);
}

function PlayerAnnounceSavePrefs()
{
	export("$PA::*", "prefs/PlayerAnnouncePrefs.cs", false);
}

function PlayerAnnounceGUI::OnWake()
{
	if(!$setcolouroptions)
	{
		PlayerJoinColourPopup.add("Red", 0);
		PlayerJoinColourPopup.add("Green", 1);
		PlayerJoinColourPopup.add("Blue", 2);
		PlayerJoinColourPopup.add("Yellow", 3);
		PlayerJoinColourPopup.add("Orange", 4);
		PlayerJoinColourPopup.add("White", 5);
		PlayerJoinColourPopup.add("Black", 6);

		ObsDropColourPopup.add("Red", 0);
		ObsDropColourPopup.add("Green", 1);
		ObsDropColourPopup.add("Blue", 2);
		ObsDropColourPopup.add("Yellow", 3);
		ObsDropColourPopup.add("Orange", 4);
		ObsDropColourPopup.add("White", 5);
		ObsDropColourPopup.add("Black", 6);

		TeamDropColourPopup.add("Red", 0);
		TeamDropColourPopup.add("Green", 1);
		TeamDropColourPopup.add("Blue", 2);
		TeamDropColourPopup.add("Yellow", 3);
		TeamDropColourPopup.add("Orange", 4);
		TeamDropColourPopup.add("White", 5);
		TeamDropColourPopup.add("Black", 6);

		EnemyDropColourPopup.add("Red", 0);
		EnemyDropColourPopup.add("Green", 1);
		EnemyDropColourPopup.add("Blue", 2);
		EnemyDropColourPopup.add("Yellow", 3);
		EnemyDropColourPopup.add("Orange", 4);
		EnemyDropColourPopup.add("White", 5);
		EnemyDropColourPopup.add("Black", 6);

		PlayerDropColourPopup.add("Red", 0);
		PlayerDropColourPopup.add("Green", 1);
		PlayerDropColourPopup.add("Blue", 2);
		PlayerDropColourPopup.add("Yellow", 3);
		PlayerDropColourPopup.add("Orange", 4);
		PlayerDropColourPopup.add("White", 5);
		PlayerDropColourPopup.add("Black", 6);

		SelfJoinTeamColourPopup.add("Red", 0);
		SelfJoinTeamColourPopup.add("Green", 1);
		SelfJoinTeamColourPopup.add("Blue", 2);
		SelfJoinTeamColourPopup.add("Yellow", 3);
		SelfJoinTeamColourPopup.add("Orange", 4);
		SelfJoinTeamColourPopup.add("White", 5);
		SelfJoinTeamColourPopup.add("Black", 6);

		SelfJoinObsColourPopup.add("Red", 0);
		SelfJoinObsColourPopup.add("Green", 1);
		SelfJoinObsColourPopup.add("Blue", 2);
		SelfJoinObsColourPopup.add("Yellow", 3);
		SelfJoinObsColourPopup.add("Orange", 4);
		SelfJoinObsColourPopup.add("White", 5);
		SelfJoinObsColourPopup.add("Black", 6);

		PlayerJoinObsColourPopup.add("Red", 0);
		PlayerJoinObsColourPopup.add("Green", 1);
		PlayerJoinObsColourPopup.add("Blue", 2);
		PlayerJoinObsColourPopup.add("Yellow", 3);
		PlayerJoinObsColourPopup.add("Orange", 4);
		PlayerJoinObsColourPopup.add("White", 5);
		PlayerJoinObsColourPopup.add("Black", 6);

		PlayerJoinSelfTeamColourPopup.add("Red", 0);
		PlayerJoinSelfTeamColourPopup.add("Green", 1);
		PlayerJoinSelfTeamColourPopup.add("Blue", 2);
		PlayerJoinSelfTeamColourPopup.add("Yellow", 3);
		PlayerJoinSelfTeamColourPopup.add("Orange", 4);
		PlayerJoinSelfTeamColourPopup.add("White", 5);
		PlayerJoinSelfTeamColourPopup.add("Black", 6);

		PlayerJoinEnemyTeamColourPopup.add("Red", 0);
		PlayerJoinEnemyTeamColourPopup.add("Green", 1);
		PlayerJoinEnemyTeamColourPopup.add("Blue", 2);
		PlayerJoinEnemyTeamColourPopup.add("Yellow", 3);
		PlayerJoinEnemyTeamColourPopup.add("Orange", 4);
		PlayerJoinEnemyTeamColourPopup.add("White", 5);
		PlayerJoinEnemyTeamColourPopup.add("Black", 6);

		PlayerJoinTeamColourPopup.add("Red", 0);
		PlayerJoinTeamColourPopup.add("Green", 1);
		PlayerJoinTeamColourPopup.add("Blue", 2);
		PlayerJoinTeamColourPopup.add("Yellow", 3);
		PlayerJoinTeamColourPopup.add("Orange", 4);
		PlayerJoinTeamColourPopup.add("White", 5);
		PlayerJoinTeamColourPopup.add("Black", 6);

		$setcolouroptions = true;
	}

	PlayerJoinColourPopup.setSelected($PA::PlayerJoinId);
	ObsDropColourPopup.setSelected($PA::ObsDropId);
	TeamDropColourPopup.setSelected($PA::TeamDropId);
	EnemyDropColourPopup.setSelected($PA::EnemyDropId);
	PlayerDropColourPopup.setSelected($PA::PlayerDropId);
	SelfJoinTeamColourPopup.setSelected($PA::SelfJoinTeamId);
	SelfJoinObsColourPopup.setSelected($PA::SelfJoinObsId);
	PlayerJoinObsColourPopup.setSelected($PA::PlayerJoinObsId);
	PlayerJoinSelfTeamColourPopup.setSelected($PA::PlayerJoinSelfTeamId);
	PlayerJoinEnemyTeamColourPopup.setSelected($PA::PlayerJoinEnemyTeamId);
	PlayerJoinTeamColourPopup.setSelected($PA::PlayerJoinTeamId);
}

new GuiControl(PlayerAnnounceGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "325 425";
	minExtent = "325 425";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "325 425";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 10";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::Sounds";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Sounds";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 10";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::ObsLeaveServer";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Obs Left Game";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 35";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::YouJoinTeam";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "You Join Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 35";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::YouJoinObs";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "You Join Obs";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 60";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TheyJoinTeam";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Player Join Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 60";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TheyJoinObs";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Player Join Obs";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 85";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TheyJoinYourTeam";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Player Join Your Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 85";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TheyJoinEnemyTeam";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Player Join Enemy Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 110";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TheyJoinServer";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Player Join Game";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 110";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TheyLeaveServer";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Player Left Game";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 135";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::TeamMateLeaveServer";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "TeamMate Left Game";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 135";
			extent = "150 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::EnemyLeaveServer";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			text = "Enemy Left Game";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "45 160";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Hide Delay (ms)";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl() {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 170";
			extent = "110 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$PA::Time";
			command = "PlayerAnnounceSavePrefs();";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "210 160";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player Join";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(PlayerJoinColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 170";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::PlayerJoinId = PlayerJoinColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "60 200";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player Drop";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(PlayerDropColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 210";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::PlayerDropId = PlayerDropColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "200 200";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Observer Drop";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(ObsDropColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 210";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::ObsDropId = ObsDropColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 240";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Teammate Drop";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(TeamDropColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 250";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::TeamDropId = TeamDropColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "205 240";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Enemy Drop";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(EnemyDropColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 250";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::EnemyDropId = EnemyDropColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 280";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "You Join Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(SelfJoinTeamColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 290";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::SelfJoinTeamId = SelfJoinTeamColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "200 280";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "You Join Obs";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(SelfJoinObsColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 290";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::SelfJoinObsId = SelfJoinObsColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 320";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player Join Obs";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(PlayerJoinObsColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 330";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::PlayerJoinObsId = PlayerJoinObsColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "195 320";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player Join Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(PlayerJoinTeamColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 330";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::PlayerJoinTeamId = PlayerJoinTeamColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "40 360";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player Join Your Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(PlayerJoinSelfTeamColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 370";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::PlayerJoinSelfTeamId = PlayerJoinSelfTeamColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "185 360";
			extent = "160 20";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player Join Enemy Team";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellPopupMenu(PlayerJoinEnemyTeamColourPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "160 370";
			extent = "160 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			command = "$PA::PlayerJoinEnemyTeamId = PlayerJoinEnemyTeamColourPopup.getSelected(); PlayerAnnounceSavePrefs();";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
	};
};